###############

# @Author: 	Martin Takac, Majid Jahani, Brian Davison
# @Email:       mat614@lehigh.edu, maj316@lehigh.edu, bdd3@lehigh.edu
# @Date:        2018-01-10

###############

#-------------------------------------------
# LOAD LIBRARIES
#-------------------------------------------
library(RCurl);
library(ggplot2)

library(data.table);
library(stats)

 
####################################################################

#
#            THIS IS THE FIRST REGRESSION
#
#
####################################################################


# From Slide 37 ----------------------------

d <- read.csv(file="UC2_TS_30.dat", header=TRUE, sep=",")
#d <- read.csv(file="UC2_TS_15.dat", header=TRUE, sep=",")

yOld <- d$o1
y <- d$n1
vol <- d$v
 
m<-nls(y~ (1+a/vol)*yOld - a*b/vol   )

summary(m)

# ------------------------------------------


#get some estimation of goodness of fit
cor(y,predict(m))

# From Slide 38 ----------------------------

predicted <- fitted(m)
errors <- resid(m)
plot( predicted ,errors, main = "Residuals vs. predicted ADF" )

# ------------------------------------------

qqnorm(errors, 
       ylab="Residuals", 
       xlab="Normal Scores", 
       main="Normality test") 
qqline(errors)


####################################################################
#  Real vs  prediction
d <- read.csv(file="UC2_TS_15.dat", header=TRUE, sep=",")
yOld <- d$o1
y <- d$n1
vol <- d$v
m<-nls(y~ (1+a/vol)*yOld - a*b/vol   )
m

# From Slide 39 ----------------------------

nd <- read.csv(file="UC2_Prediction.dat", header=TRUE, sep=",")

x<-seq(0,58*4,1)*0.25
y<-x*0
y[1] <- nd$m1[1]
vol <- nd$v[1]
alpha <- summary(m)$coefficients[1]
beta <- summary(m)$coefficients[2]
alpha
beta
for (i in 2:length(x)){
   y[i] <- (1+alpha/vol)*y[i-1] - alpha*beta/vol  
}
y

plot(nd$t/60,nd$m1,xlab = "Time Since Cooling [hours]", ylab='Temperature [F]',type='l',col="red")
lines(x,y ,type="s", col="blue")

# ------------------------------------------

