###############

# @Author: 	Martin Takac, Majid Jahani, Brian Davison
# @Email:       mat614@lehigh.edu, maj316@lehigh.edu, bdd3@lehigh.edu
# @Date:        2018-04-10

###############

#-------------------------------------------
# LOAD LIBRARIES
#-------------------------------------------
library(RCurl);
library(ggplot2)

library(data.table);
library(segmented)

library(plot3D) 
require(scatterplot3d)


MyData <- read.csv(file="lec3_data.txt", header=FALSE, sep=",")
labels <- MyData$V1
n <- length(labels)
data <- MyData[1:n,2:32]


beers.data <- (data) # standardize variables
beers.labels <- (labels+1)
hist(beers.labels,15)

# From Slide 43 ----------------------------

# apply PCA - scale. = TRUE is highly 
# advisable, but default is FALSE. 
beers.pca <- prcomp(beers.data,
                 center = TRUE,
                 scale. = TRUE) 
#print(beers.pca)


plot(beers.pca, type = "l")

# ------------------------------------------

summary(beers.pca)

# From Slide 44 ----------------------------

# Predict PCs
beers.projected <- predict(beers.pca, newdata=beers.data)
beers.labels


scatterplot3d(beers.projected[,1],
              beers.projected[,2],
              beers.projected[,3],
              color = beers.labels,
              main = "PCA"
              )

# ------------------------------------------  









